<?php
/**
* @version      2.3.0 25.09.2010
* @author       MAXXmarketing GmbH
* @package      Jshopping
* @copyright    Copyright (C) 2010 webdesigner-profi.de. All rights reserved.
* @license      GNU/GPL
*/

defined( '_JEXEC' ) or die( 'Restricted access' );
jimport('joomla.application.component.controller');
include_once(JPATH_COMPONENT_SITE."/payments/payment.php");

class JshoppingControllerCheckout extends JController{
    
    function step2(){                                        
        $this->_check(2);
        
        $session =& JFactory::getSession();
        $user = &JFactory::getUser();
        $jshopConfig = &JSFactory::getConfig();
        $country = &JTable::getInstance('country', 'jshop');
        
        $checkLogin = JRequest::getInt('check_login');
        if ($checkLogin){            
            $session->set("show_pay_without_reg", 1);
            checkUserLogin();
        }
        
        appendPathWay(_JSHOP_CHECKOUT_ADDRESS);
        $this->showCheckoutNavigation(2);
        
        $cart = &JModel::getInstance('cart', 'jshop');
        $cart->load();
        $cart->getSum();
                
        $cart->refreshCartWithNewCurrency();
        if ($user->id){
            $adv_user = &JSFactory::getUserShop();
        }else{
            $adv_user = &JSFactory::getUserShopGuest();    
        }
        
        $view=&$this->getView("checkout", 'html');
        $view->setLayout("adress");
                
        $agb = sprintf(_JSHOP_LINK_AGB, SEFLink('index.php?option=com_jshopping&controller=content&task=view&page=agb'),SEFLink('index.php?option=com_jshopping&controller=content&task=view&page=return_policy'));
        $view->assign('select', $jshopConfig->arr['title']);

        $option_country[] = JHTML::_('select.option',  '0', _JSHOP_REG_SELECT, 'country_id', 'name' );
        $option_countryes = array_merge($option_country, jshopCountry::getAllCountries());
        $select_countries = JHTML::_('select.genericlist', $option_countryes, 'country', 'id = "country" class = "inputbox" size = "1"','country_id', 'name', $adv_user->country );
        $select_d_countries = JHTML::_('select.genericlist', $option_countryes, 'd_country', 'id = "d_country" class = "inputbox" size = "1"','country_id', 'name', $adv_user->d_country);

        foreach ($jshopConfig->arr['title'] as $key => $value) {                
            $option_title[] = JHTML::_('select.option', $key, $value, 'title_id', 'title_name');
        }            
        $select_titles = JHTML::_('select.genericlist', $option_title, 'title', 'class = "inputbox" id = "title"','title_id', 'title_name', $adv_user->title);            
        $select_d_titles = JHTML::_('select.genericlist', $option_title, 'd_title', 'class = "inputbox" id = "d_title"','title_id', 'title_name', $adv_user->d_title);

        $view->assign('select_countries', $select_countries);
        $view->assign('select_d_countries', $select_d_countries);
        $view->assign('select_titles', $select_titles);
        $view->assign('select_d_titles', $select_d_titles);
        $view->assign('live_path', JURI::base());
        
        filterHTMLSafe( $adv_user, ENT_QUOTES);
        
        $view->assign('user', $adv_user);
        $view->assign('agb', $agb);
        $view->assign('delivery_adress', $adv_user->delivery_adress);
        $view->assign('action', SEFLink('index.php?option=com_jshopping&controller=checkout&task=step2save'));         
        $view->display();    
    }
    
    function step2save(){
        
        $this->_check(2);
                   
        $post = JRequest::get('post');
        if (!count($post)){
            JError::raiseWarning("",_JSHOP_ERROR_DATA);
            $this->setRedirect(SEFLink('index.php?option=com_jshopping&controller=checkout&task=step2',0,1));
            return 0;
        }
        
        unset($post['user_id']);
        unset($post['usergroup_id']);
        
        $user = &JFactory::getUser();
        if ($user->id){
            $adv_user = &JTable::getInstance('userShop', 'jshop');        
            $adv_user->load($user->id);
        }else{
            $adv_user = &JSFactory::getUserShopGuest();
        }
        
        $adv_user->bind($post);
        if(!$adv_user->check(1)) {
            JError::raiseWarning("",$adv_user->getError());
            $this->setRedirect(SEFLink('index.php?option=com_jshopping&controller=checkout&task=step2',0,1));
            return 0;
        }
        
        if(!$adv_user->store()) {
            JError::raiseWarning("",_JSHOP_REGWARN_ERROR_DATABASE);
            $this->setRedirect(SEFLink('index.php?option=com_jshopping&controller=checkout&task=step2',0,1));
            return 0;
        }
        
        if ($user->id){
            $user = clone(JFactory::getUser());
            $user->email = $adv_user->email;
            $user->save();
        }

        $this->_setMaxStep(3);
        
        $this->setRedirect(SEFLink('index.php?option=com_jshopping&controller=checkout&task=step3',0,1));
    }
    
    function step3(){
    
    	$this->_check(3);
    	
        $session =& JFactory::getSession();
    	appendPathWay(_JSHOP_CHECKOUT_PAYMENT);
        $this->showCheckoutNavigation(3);
                
        $jshopConfig = &JSFactory::getConfig();
        
        $paymentmethod = &JTable::getInstance('paymentmethod', 'jshop');
        $all_payment_methods = jshopPaymentMethod::getAllPaymentMethods();
        $i = 0;
        $paym = array();
        foreach ($all_payment_methods as $pm) {
            if (file_exists($jshopConfig->path . 'payments/'.$pm->payment_class."/".$pm->payment_class.'.php')){
                require_once ($jshopConfig->path . 'payments/'.$pm->payment_class."/".$pm->payment_class.'.php');
                $paym[$i]->existentcheckform = 1;
            }else{
                $paym[$i]->existentcheckform = 0;
            }
            
            $paym[$i]->name = $pm->name;
            $paym[$i]->payment_id = $pm->payment_id;
            $paym[$i]->payment_class = $pm->payment_class;
            $paym[$i]->payment_description = $pm->description;
            
            $s_payment_method_id = $session->get('payment_method_id');
            if ($s_payment_method_id == $pm->payment_id){
                $params = $session->get('pm_params'); 
            }else{
                $params = array();
            }
            if ($paym[$i]->existentcheckform){
                ob_start();
                call_user_func(array($pm->payment_class, 'showPaymentForm'), $params);
                $paym[$i]->form = ob_get_contents();
                ob_get_clean();
            }else{
                $paym[$i]->form = "";
            }
            
            $i++;           
        }
        
        $s_payment_method_id = $session->get('payment_method_id');
        $active_payment = intval($s_payment_method_id);
        if (!$active_payment){
            if (isset($paym[0])){
                $active_payment = $paym[0]->payment_id;
            }
        }
        
        $view=&$this->getView("checkout", 'html');
        $view->setLayout("payments");
        
        $view->assign('payment_methods', $paym);
        $view->assign('active_payment', $active_payment);
        $view->assign('action', SEFLink('index.php?option=com_jshopping&controller=checkout&task=step3save'));
        $view->display();    
    }
    
    function step3save(){
        
        $this->_check(3);
        
        $session =& JFactory::getSession();
        $jshopConfig = &JSFactory::getConfig(); 
        $post = JRequest::get('post');
         if (!count($post)){
            JError::raiseWarning("",_JSHOP_ERROR_DATA);
            $this->setRedirect(SEFLink('index.php?option=com_jshopping&controller=checkout&task=step3',0,1));
            return 0;
        }
        
        $payment_method = JRequest::getVar('payment_method'); //class payment method
        $params = JRequest::getVar('params');
        $params_pm = $params[$payment_method];
        
        if (!file_exists($jshopConfig->path . 'payments/'.$payment_method."/".$payment_method.'.php')) {
            $existentcheckform = 0;
        }else{
            $existentcheckform = 1;
            include_once($jshopConfig->path . 'payments/'.$payment_method."/".$payment_method.'.php');
            
            if (!class_exists($payment_method)) {
                $session->set('pm_method', '');
                $session->set('pm_params', '');            
                JError::raiseWarning(500, _JSHOP_ERROR_PAYMENT);
                $this->setRedirect(SEFLink('index.php?option=com_jshopping&controller=checkout&task=step3',0,1));
                return 0;
            }
            
            if (!call_user_func( array($payment_method, 'checkPaymentInfo'), $params_pm)) {
                $session->set('pm_method', '');
                $session->set('pm_params', '');
                JError::raiseWarning(500, _JSHOP_ERROR_PAYMENT);
                $this->setRedirect(SEFLink('index.php?option=com_jshopping&controller=checkout&task=step3',0,1));
                return 0;
            }
            
        }                        
                
        $paym_method = &JTable::getInstance('paymentmethod', 'jshop');
        $paym_method->class = $payment_method;
        $session->set('payment_method_id', $paym_method->getId());
        
        if(isset($params[$payment_method])) {            
            $session->set('pm_params', $params_pm);
        } else {            
            $session->set('pm_params', '');
        }
        
        $this->_setMaxStep(4);
        
        $this->setRedirect(SEFLink('index.php?option=com_jshopping&controller=checkout&task=step4',0,1));
    }
    
    function step4(){
        
        $this->_check(4);
        appendPathWay(_JSHOP_CHECKOUT_SHIPPING);
        $this->showCheckoutNavigation(4);
        
        $session =& JFactory::getSession();
        $jshopConfig = &JSFactory::getConfig(); 
        
        if ($jshopConfig->without_shipping) {
        	$this->_setMaxStep(5);
            $session->set('shipping_method_id', 0);
            $session->set('jshop_price_shipping', 0);            
            $this->setRedirect(SEFLink('index.php?option=com_jshopping&controller=checkout&task=step5',0,1));
            return 0; 
        }
        
        $user = &JFactory::getUser();
        if ($user->id){
            $adv_user = &JSFactory::getUserShop();
        }else{
            $adv_user = &JSFactory::getUserShopGuest();    
        }
        
        $shippingmethod = &JTable::getInstance('shippingMethod', 'jshop');
        $shippingmethodprice = &JTable::getInstance('shippingMethodPrice', 'jshop');
        
        if ($adv_user->delivery_adress){
            $id_country = $adv_user->d_country;
        }else{
            $id_country = $adv_user->country;
        }
        $shippings = jshopShippingMethod::getAllShippingMethodsCountry($id_country);
        foreach ($shippings as $key => $value) {
            $shippings[$key]->shipping_price = jshopShippingMethodPrice::getPricesWeight($value->sh_pr_method_id, $jshopConfig->currency_value, $id_country);
            $shippings[$key]->shipping_stand_price = $shippings[$key]->shipping_stand_price * $jshopConfig->currency_value;
        }
        
        
        $sh_pr_method_id = $session->get("sh_pr_method_id");
        $active_shipping = intval($sh_pr_method_id);
        if (!$active_shipping){
            if (isset($shippings[0])){
                $active_shipping = $shippings[0]->sh_pr_method_id;
            }
        }
        
        $view=&$this->getView("checkout", 'html');
        $view->setLayout("shippings");                
        
        $view->assign('shipping_methods', $shippings);
        $view->assign('active_shipping', $active_shipping);
        $view->assign('action', SEFLink('index.php?option=com_jshopping&controller=checkout&task=step4save'));
        
        $view->display();
    }
    
    function step4save(){
    
    	$this->_check(4);
    	
        $session =& JFactory::getSession();
        $jshopConfig = &JSFactory::getConfig();
        $user = &JFactory::getUser();
        if ($user->id){
            $adv_user = &JSFactory::getUserShop();
        }else{
            $adv_user = &JSFactory::getUserShopGuest();    
        }
        $cart = &JModel::getInstance('cart', 'jshop');
        $cart->load();
        
        if ($adv_user->delivery_adress){
            $id_country = $adv_user->d_country;
        }else{
            $id_country = $adv_user->country;
        }
        
        $sh_pr_method_id = JRequest::getInt('sh_pr_method_id');
                
        $shipping_method_price = &JTable::getInstance('shippingMethodPrice', 'jshop');        
        $shipping_method_price->load($sh_pr_method_id);
        
        $sh_method = &JTable::getInstance('shippingMethod', 'jshop');
        $sh_method->load($shipping_method_price->shipping_method_id);
        
        if (!$shipping_method_price->sh_pr_method_id){            
            JError::raiseWarning("", _JSHOP_ERROR_SHIPPING);
            $this->setRedirect(SEFLink('index.php?option=com_jshopping&controller=checkout&task=step4',0,1));
            return 0;
        }
        
        if (!$shipping_method_price->isCorrectMethodForCountry($id_country)){            
            JError::raiseWarning("",_JSHOP_ERROR_SHIPPING);
            $this->setRedirect(SEFLink('index.php?option=com_jshopping&controller=checkout&task=step4',0,1));
            return 0;
        }
        
        if (!$sh_method->shipping_id){            
            JError::raiseWarning("", _JSHOP_ERROR_SHIPPING);
            $this->setRedirect(SEFLink('index.php?option=com_jshopping&controller=checkout&task=step4',0,1));
            return 0;
        }
        
        $price_shipping = $shipping_method_price->calculateSum($cart);
        
        $session->set("shipping_method_id", $sh_method->shipping_id); //shiping method id
        $session->set("sh_pr_method_id", $sh_pr_method_id); //shiping price method id         
        $session->set("jshop_price_shipping", $price_shipping);
        $session->set("jshop_price_shipping_tax", $shipping_method_price->calculateTax($price_shipping));
        $session->set("jshop_price_shipping_tax_percent", $shipping_method_price->getTax());                
        
        $this->_setMaxStep(5);
                
        $this->setRedirect(SEFLink('index.php?option=com_jshopping&controller=checkout&task=step5',0,1));
    }
    
    function step5(){
        
        $this->_check(5);
        appendPathWay(_JSHOP_CHECKOUT_PREVIEW);
        $this->showCheckoutNavigation(5);               
        
        $session =& JFactory::getSession();        
        $jshopConfig = &JSFactory::getConfig(); 
        $user = &JFactory::getUser();
        if ($user->id){
            $adv_user = &JSFactory::getUserShop();
        }else{
            $adv_user = &JSFactory::getUserShopGuest();    
        }
        
        $this->showSmallCart(5);
                
        $sh_method = &JTable::getInstance('shippingMethod', 'jshop');
        $shipping_method_id = $session->get("shipping_method_id");
        $sh_method->load($shipping_method_id);
        
        $pm_method = &JTable::getInstance('paymentMethod', 'jshop');
        $payment_method_id = $session->get("payment_method_id");
		$pm_method->load($payment_method_id);
				
        $lang = &JSFactory::getLang();
        
		if($adv_user->delivery_adress) {
            $country = &JTable::getInstance('country', 'jshop');
            $country->load($adv_user->d_country);
            
			$delivery_info['f_name'] = $adv_user->d_f_name;
			$delivery_info['l_name'] = $adv_user->d_l_name;
			$delivery_info['street'] = $adv_user->d_street;
			$delivery_info['zip'] = $adv_user->d_zip;
			$delivery_info['state'] = $adv_user->d_state;
            $delivery_info['city'] = $adv_user->d_city;
            $field_country_name = $lang->get("name");
			$delivery_info['country'] = $country->$field_country_name;
		} else {
            $country = &JTable::getInstance('country', 'jshop');
            $country->load($adv_user->country);
            
			$delivery_info['f_name'] = $adv_user->f_name;
			$delivery_info['l_name'] = $adv_user->l_name;
			$delivery_info['street'] = $adv_user->street;
			$delivery_info['zip'] = $adv_user->zip;
			$delivery_info['state'] = $adv_user->state;
            $delivery_info['city'] = $adv_user->city;
            $field_country_name = $lang->get("name");
			$delivery_info['country'] = $country->$field_country_name;
		}
		
		$view=&$this->getView("checkout", 'html');
        $view->setLayout("previewfinish");        
                
        $lang = &JSFactory::getLang();
        $name = $lang->get("name");
        $sh_method->name = $sh_method->$name;
		$view->assign('sh_method', $sh_method );    
		$view->assign('payment_name', $pm_method->$name);
		$view->assign('delivery_info', $delivery_info);
        $view->assign('action', SEFLink('index.php?option=com_jshopping&controller=checkout&task=step5save'));       
		$view->assign('config', $jshopConfig);

    	$view->display();
    }
    
    function step5save(){
    global $mainframe;    
        $this->_check(5);
        
        $lang = &JSFactory::getLang();
        $user = &JFactory::getUser();
        if ($user->id){
            $adv_user = &JSFactory::getUserShop();
        }else{
            $adv_user = &JSFactory::getUserShopGuest();    
        }
        $cart = &JModel::getInstance('cart', 'jshop');
        $cart->load();
        
        $session =& JFactory::getSession();
        $jshopConfig = &JSFactory::getConfig();
        $db = &JFactory::getDBO();        
        
        $payment_method_id = $session->get('payment_method_id');
        $pm_method = &JTable::getInstance('paymentMethod', 'jshop');
        $pm_method->load($payment_method_id);        

        $payment_method = $pm_method->payment_class; 
        
        if(!file_exists($jshopConfig->path . 'payments/' . $payment_method."/".$payment_method. '.php')) {
            $paymentSystemVerySimple = 1;
        }else{ 
            $paymentSystemVerySimple = 0;
            
            include_once ($jshopConfig->path . 'payments/' . $payment_method."/".$payment_method . '.php');        

            if(!class_exists($payment_method)) {
                $session->set('pm_method', '');
                $session->set('pm_params', '');
                JError::raiseWarning("",_JSHOP_ERROR_PAYMENT);
                $this->setRedirect(SEFLink('index.php?option=com_jshopping&controller=checkout&task=step3',0,1));
                return 0;
            }
        }
                
        $order = &JTable::getInstance('order', 'jshop');
        $arr_property = array('user_id','f_name','l_name','firma_name','email','street','zip','city','state','country','phone','fax','title','d_f_name','d_l_name','d_firma_name','d_street','d_zip','d_city','d_state','d_country','d_phone','d_title');

        foreach ($adv_user as $key => $value) {
            if(in_array($key, $arr_property)) {
                $order->$key = $value;
            }
        }
        
        $order->order_date = $order->order_m_date = date("Y-m-d H:i:s",mktime());
        $order->order_tax = $cart->getTax(1,1);        
        $order->setTaxExt($cart->getTaxExt(1,1));
        $order->order_subtotal = $cart->getPriceProducts();        
        $order->order_shipping = $cart->getShippingPrice();
        $order->order_discount = $cart->rabatt_summ;
        $order->order_total = $cart->getSum(1,1);
        
        $order->order_status = $jshopConfig->default_status_order;
                
        $order->shipping_method_id = $session->get('shipping_method_id');        
        $order->payment_method_id = $session->get('payment_method_id');
        
        $pm_params = $session->get("pm_params");
        
        if(is_array($pm_params) && !$paymentSystemVerySimple) {
            $order->payment_params = replaceArray($pm_params, call_user_func(array($payment_method, 'getParams')) );
        }
        
        $name = $lang->get("name");
        $order->payment_params = _JSHOP_FINISH_PAYMENT_METHOD . ": " . $pm_method->$name . "\n" . $order->payment_params;
        $order->ip_address = $_SERVER['REMOTE_ADDR'];
        $order->order_add_info = JRequest::getVar('order_add_info','');
        $order->currency_code = $jshopConfig->currency_code;
        $order->order_number = outputDigit(jshopOrder::getLastOrderId(),8); //not safe mathod
        $order->order_hash = md5(time().$order->order_total.$order->user_id);
        $order->file_hash = md5(time().$order->order_total.$order->user_id."hashfile");
        
        if (!$adv_user->delivery_adress) $order->copyDeliveryData();

        if(!$order->store()) {
            JError::raiseWarning("", $order->getError());
            $this->setRedirect(SEFLink('index.php?option=com_jshopping&controller=checkout&task=step5',0,1));
            return 0;            
        }
                
        if ($cart->getCouponId()){
            $coupon = &JTable::getInstance('coupon', 'jshop');
            $coupon->load($cart->getCouponId());
            if ($coupon->finished_after_used){                
                $coupon->used = $adv_user->user_id;
                $coupon->store();
            }
        }
        
        $cart->addOrderItem($order->order_id);
        $session->set("jshop_end_order_id", $order->order_id);
        
        $order_history = &JTable::getInstance('orderHistory', 'jshop');    
        $order_history->order_id = $order->order_id;
        $order_history->order_status_id = $order->order_status;
        $order_history->status_date_added = $order->order_date;
        $order_history->customer_notify = 1;
        $order_history->store();

        // change data for send email       
        $status = &JTable::getInstance('orderStatus', 'jshop');
        $status->load($order->order_status);
        $name = $lang->get("name");
        $order->status = $status->$name;
        $order->order_date = strftime($jshopConfig->store_date_format, strtotime($order->order_date));
        $order->products = $cart->products;
        $order->order_shipping_tax = $session->get('jshop_price_shipping_tax');
        $order->order_tax_list = $cart->getTaxExt(1,1);        
        $show_percent_tax = 0;        
        if (count($order->order_tax_list)>1 || $jshopConfig->show_tax_in_product) $show_percent_tax = 1;
        
        $country = &JTable::getInstance('country', 'jshop');
        $country->load($order->country);
        $field_country_name = $lang->get("name");
        $order->country = $country->$field_country_name;        
        
        $d_country = &JTable::getInstance('country', 'jshop');
        $d_country->load($order->d_country);
        $field_country_name = $lang->get("name");
        $order->d_country = $d_country->$field_country_name;
        
        $shippingMethod = &JTable::getInstance('shippingMethod', 'jshop');
        $shippingMethod->load($order->shipping_method_id);
        
        $name = $lang->get("name");
        $description = $lang->get("description");
        $order->shipping_information = $shippingMethod->$name;
        $order->payment_information = $order->payment_params;
        if ($pm_method->show_descr_in_email) $order->payment_description = $pm_method->$description;  else $order->payment_description = "";
        
        $query = "SELECT order_email_descr FROM `#__jshopping_config_main_page` WHERE language = '".$jshopConfig->cur_lang."'";
        $db->setQuery($query);
        $order_email_descr = $db->loadResult();
                
        $text_total = _JSHOP_ENDTOTAL;
        if ($jshopConfig->show_tax_in_product || $jshopConfig->show_tax_product_in_cart){
            $text_total = _JSHOP_ENDTOTAL_INKL_TAX;
        }
        
        $client = 1;
        $view=&$this->getView("checkout", 'html');
        $view->setLayout("orderemail");
        $view->assign('client', $client);
        $view->assign('order_email_descr', $order_email_descr);
        $view->assign('config', $jshopConfig);
        $view->assign('order',$order);
        $view->assign('show_percent_tax', $show_percent_tax);
        $view->assign('noimage',"noimage.gif");    
        $view->assign('text_total',$text_total);    
        $message_client = $view->loadTemplate(); 
        
        $client = 0;
        $view=&$this->getView("checkout", 'html');
        $view->setLayout("orderemail");
        $view->assign('client', $client);
        $view->assign('config', $jshopConfig);
        $view->assign('order',$order);
        $view->assign('show_percent_tax', $show_percent_tax);
        $view->assign('noimage',"noimage.gif");
        $view->assign('text_total',$text_total);    
        $message_admin = $view->loadTemplate();
        
        if ($jshopConfig->order_send_pdf_client || $jshopConfig->order_send_pdf_admin){
            require_once(JPATH_SITE . "/components/com_jshopping/lib/generete_pdf_order.php");
            $order->pdf_file = generatePdf($order, $jshopConfig);
            $order->insertPDF();
        }
        
        $mailfrom = $mainframe->getCfg( 'mailfrom' );
        $fromname = $mainframe->getCfg( 'fromname' );
        
        $mailer =& JFactory::getMailer();
        $mailer->setSender(array($jshopConfig->contact_email, $fromname));
        $mailer->addRecipient($adv_user->email);
        $mailer->setSubject(_JSHOP_NEW_ORDER);
        $mailer->setBody($message_client);
        if ($jshopConfig->order_send_pdf_client){
            $mailer->addAttachment($jshopConfig->pdf_orders_path."/".$order->pdf_file);
        }
        $mailer->isHTML(true);
        $send =& $mailer->Send();
        
        $mailer =& JFactory::getMailer();
        $mailer->setSender(array($jshopConfig->contact_email, $fromname));
        $mailer->addRecipient($jshopConfig->contact_email);
        $mailer->setSubject(_JSHOP_NEW_ORDER);
        $mailer->setBody($message_admin);
        if ($jshopConfig->order_send_pdf_admin){
            $mailer->addAttachment($jshopConfig->pdf_orders_path."/".$order->pdf_file);
        }
        $mailer->isHTML(true);
        $send =& $mailer->Send();
        $session->set("jshop_send_end_form", 0);
        $this->_setMaxStep(6);
        $this->setRedirect(SEFLink('index.php?option=com_jshopping&controller=checkout&task=step6',0,1));                
    }
    
    function step6(){
        $this->_check(6);
        $jshopConfig = &JSFactory::getConfig();
        $session =& JFactory::getSession();
        
        $order_id = $session->get('jshop_end_order_id');
        
        if (!$order_id){
            JError::raiseWarning("", _JSHOP_SESSION_FINISH);
            $this->setRedirect(SEFLink('index.php?option=com_jshopping&controller=checkout&task=step5',0,1));
        }
        
        $order = &JTable::getInstance('order', 'jshop');
        $order->load($order_id);
        
        // user click back in payment system 
        $jshop_send_end_form = $session->get('jshop_send_end_form');
        if ($jshop_send_end_form == 1){            
            $this->_cancelPayOrder();
            return 0;
        }                
                
        $pm_method = &JTable::getInstance('paymentMethod', 'jshop');
        $payment_method_id = $session->get('payment_method_id');
        $pm_method->load($payment_method_id);
        $payment_method = $pm_method->payment_class; 
        
        if(!file_exists($jshopConfig->path . 'payments/' . $payment_method."/".$payment_method. '.php')) {
            $paymentSystemVerySimple = 1;
        }else{
            $paymentSystemVerySimple = 0;
            include_once ($jshopConfig->path . 'payments/' . $payment_method."/".$payment_method. '.php');        

            if(!class_exists($payment_method)) {
                $session->set('pm_method','');
                $session->set('pm_params','');            
                JError::raiseWarning("",_JSHOP_ERROR_PAYMENT);
                $this->setRedirect(SEFLink('index.php?option=com_jshopping&controller=checkout&task=step3',0,1));
                return 0;
            }
        }
        
        if ($pm_method->payment_type == 1 || $paymentSystemVerySimple) { 
            $this->_setMaxStep(10);
            $this->setRedirect(SEFLink('index.php?option=com_jshopping&controller=checkout&task=finish',0,1));
            return 0;    
        }        
        
        $session->set('jshop_send_end_form', 1);
        
        $parseString = new parseString($pm_method->payment_params);                
        $params =  $parseString->parseStringToParams();
        call_user_func(array($pm_method->payment_class, 'showEndForm'), $params, $order);
    }
    
    function step7(){
    global $mainframe;
        
        $lang = &JSFactory::getLang();
        $jshopConfig = &JSFactory::getConfig();
        $session =& JFactory::getSession();
        
        //$str = "";
        //foreach($_POST as $k=>$v) $str .= $k."=".$v."\n";        
        //saveToLog("payment.log", $str);
        
        $act = JRequest::getVar("act");        
        $payment_method = JRequest::getVar("js_paymentclass");        
        
         if(!file_exists($jshopConfig->path . 'payments/' . $payment_method."/".$payment_method. '.php')) {
            saveToLog("payment.log", "#001 - Error payment method file. PM ".$payment_method);
            JError::raiseWarning("", _JSHOP_ERROR_PAYMENT);            
            return 0;
        } 
        require_once ($jshopConfig->path . 'payments/' . $payment_method."/".$payment_method. '.php');        

        if(!class_exists($payment_method)) {
            saveToLog("payment.log", "#002 - Error payment. CLASS ".$payment_method);
            JError::raiseWarning("", _JSHOP_ERROR_PAYMENT);            
            return 0;
        }
                
        $urlParamsPS = call_user_func(array($payment_method, 'getUrlParams'));
        
        $order_id = $urlParamsPS['order_id'];
        $hash = $urlParamsPS['hash'];
        $checkHash = $urlParamsPS['checkHash'];
        $checkReturnParams = $urlParamsPS['checkReturnParams'];
        
        $session->set('jshop_send_end_form', 0);
        
        if ($act == "cancel"){
            $this->_cancelPayOrder($order_id);
            return 0;
        }
        
        if ($act == "return" && !$checkReturnParams){
            $this->_setMaxStep(10);
            $this->setRedirect(SEFLink('index.php?option=com_jshopping&controller=checkout&task=finish',0,1));
            return 1;    
        }               
        
        $order = &JTable::getInstance('order', 'jshop');
        $order->load($order_id);

        if ($checkHash && $order->order_hash != $hash){
            saveToLog("payment.log", "#003 - Error order hash. Order id ".$order_id);
            JError::raiseWarning("", _JSHOP_ERROR_ORDER_HASH);
            return 0;    
        }
        
        if (!$order->payment_method_id){
            saveToLog("payment.log", "#004 - Error payment method id. Order id ".$order_id);
            JError::raiseWarning("", _JSHOP_ERROR_PAYMENT);
            return 0;    
        }        
        
        $pm_method = &JTable::getInstance('paymentMethod', 'jshop');
        $pm_method->load($order->payment_method_id);
        
        if ($payment_method != $pm_method->payment_class){
            saveToLog("payment.log", "#005 - Error payment method set url. Order id ".$order_id);
            JError::raiseWarning("", _JSHOP_ERROR_PAYMENT);
            return 0;
        }
        
        $parseString = new parseString($pm_method->payment_params);                
        $params =  $parseString->parseStringToParams();
        $res = call_user_func(array($pm_method->payment_class, 'checkTransaction'), $params, $order, $act);
        $rescode = $res[0];
        $restext = $res[1];        
        
        if ($rescode == 0 || $rescode == 3){        
            saveToLog("payment.log", $restext);
        }
        
        if ($rescode==0){
            $status = 0;
        }elseif($rescode==1){
            $status = $params['transaction_end_status'];
        }elseif($rescode==2){
            $status = $params['transaction_pending_status'];
        }elseif($rescode==3){
            $status = $params['transaction_failed_status'];
        }    
            
        if ($status && $order->order_status != $status){            
           $this->_changeStatusOrder($order_id, $status);
        }        
        
        if ($act == "notify"){ 
            call_user_func(array($pm_method->payment_class, 'nofityFinish'), $params, $order, $rescode);
            die();            
        }
              
        if ($rescode == 0 || $rescode == 3){			
            JError::raiseWarning("", $restext); 
            $this->setRedirect(SEFLink('index.php?option=com_jshopping&controller=checkout&task=step5',0,1));
            return 0;
        }else{
            $this->_setMaxStep(10);
            $this->setRedirect(SEFLink('index.php?option=com_jshopping&controller=checkout&task=finish',0,1));
            return 1;
        }
        
    }
    
    function finish(){
        $this->_check(10);
        
        $jshopConfig = &JSFactory::getConfig();
        $db = &JFactory::getDBO();
        
        $query = "SELECT order_finish_descr FROM `#__jshopping_config_main_page` WHERE language = '".$jshopConfig->cur_lang."'";
        $db->setQuery($query);
        $text = $db->loadresult();
        
        if (trim(strip_tags($text)) == ""){        
            $view=&$this->getView("checkout", 'html');
            $view->setLayout("finish");        
            $view->display();
        }else{
            print $text;
        }
        
        //clear all info order
        $cart = &JModel::getInstance('cart', 'jshop');
        $cart->load();                
        $cart->getSum();
        $cart->clear();
        $this->deleteSession();    
    }
    
    //*********************************************//
    
    function showSmallCart($step = 0){
        $jshopConfig = &JSFactory::getConfig();
        
        $cart = &JModel::getInstance('cart', 'jshop');
        $cart->load();        
        $cart->addLinkToProducts(0);
        
        $view=&$this->getView("cart", 'html');
        $view->setLayout("checkout");                                
        
        $view->assign('config', $jshopConfig);
        $view->assign('products', $cart->products);
        $view->assign('summ', $cart->getPriceProducts());
        $view->assign('image_product_path', $jshopConfig->image_product_live_path);
        $view->assign('image_path', $jshopConfig->live_path);
        $view->assign('no_image', 'noimage.gif');
        $view->assign('rabatt_summ', $cart->rabatt_summ);                                
        
        if ($step == 5 && !$jshopConfig->without_shipping) {
            $view->assign('summ_delivery', $cart->getShippingPrice());
            $fullsumm = $cart->getSum(1,1);
            $tax_list = $cart->getTaxExt(1,1);
        }else{
            $fullsumm = $cart->getSum(0,1);
            $tax_list = $cart->getTaxExt(0,1);
        }
        
        $text_total = _JSHOP_PRICE_TOTAL;
        if ($step == 5){
            $text_total = _JSHOP_ENDTOTAL;
            if ($jshopConfig->show_tax_in_product || $jshopConfig->show_tax_product_in_cart){
                $text_total = _JSHOP_ENDTOTAL_INKL_TAX;
            }
        }
        
        $show_percent_tax = 0;        
        if (count($tax_list)>1 || $jshopConfig->show_tax_in_product) $show_percent_tax = 1;
        
        $view->assign('tax_list', $tax_list);
        $view->assign('fullsumm', $fullsumm);        
        $view->assign('show_percent_tax', $show_percent_tax);
        $view->assign('text_total', $text_total);
                
        $view->display();
    }
    
    function showCheckoutNavigation($step) {
    
        $jshopConfig = &JSFactory::getConfig();
        $array_navigation_steps = array('2' => _JSHOP_STEP_ORDER_2, '3' => _JSHOP_STEP_ORDER_3, '4' => _JSHOP_STEP_ORDER_4, '5' => _JSHOP_STEP_ORDER_5);        
        $output = array();        
        if ($jshopConfig->without_shipping) unset($array_navigation_steps[4]);
        
        foreach ($array_navigation_steps as $key => $value) {
            if($key < $step){
                $output[] = '<a href = "'.SEFLink('index.php?option=com_jshopping&controller=checkout&task=step'.$key).'">' . $value . '</a>';
            } else{
                if($key == $step)
                    $output[] = '<span id = "active_step">' . $value . '</span>';
                else
                    $output[] = $value;
            }
        }
        
        $view=&$this->getView("checkout", 'html');
        $view->setLayout("menu");
        
        $view->assign('steps', $output);
        $view->display();
    }
    
    function _check($step){
    global $mainframe;
        
        $jshopConfig = &JSFactory::getConfig();
        $session =& JFactory::getSession();        
        
        if ($step<10){
            
            if (!$jshopConfig->shop_user_guest){
                checkUserLogin();
            }
            
            $cart = &JModel::getInstance('cart', 'jshop');
            $cart->load();
                                
            if($cart->getCountProduct() == 0) {
                JError::raiseWarning("", _JSHOP_NO_SELECT_PRODUCT);
                $mainframe->redirect(SEFLink('index.php?option=com_jshopping&controller=cart&task=view',0,1));
                exit();
            }
        }
        
        if ($step>2){
            $jhop_max_step = $session->get("jhop_max_step");
        	if (!$jhop_max_step){
                $session->set('jhop_max_step', 2);
                $jhop_max_step = 2;
            }
        	if ($step > $jhop_max_step){
	        	JError::raiseWarning("", _JHOP_ERROR_STEP);
	            $mainframe->redirect(SEFLink('index.php?option=com_jshopping&controller=checkout&task=step'.$jhop_max_step,0,1));
        	}
        }
    }
    
    function _changeStatusOrder($order_id, $status){
    global $mainframe;
        
        $lang = &JSFactory::getLang();
        $jshopConfig = &JSFactory::getConfig();
            
        $order = &JTable::getInstance('order', 'jshop');
        $order->load($order_id);
        $order->order_status = $status;
        $order->store();
        
        $order_status = &JTable::getInstance('orderStatus', 'jshop');                
        $order_status->load($status);        
        
        $order_history = &JTable::getInstance('orderHistory', 'jshop');
        $order_history->order_id = $order->order_id;
        $order_history->order_status_id = $status;
        $order_history->status_date_added = date("Y-m-d H:i:s");
        $order_history->customer_notify = 1;
        $order_history->comments  = $restext;
        $order_history->store();
        
        $name = $lang->get("name");
        $message = sprintf(_JSHOP_ORDER_STATUS_CHANGE, $order->order_number, $order_status->$name); 
        $mailfrom = $mainframe->getCfg( 'mailfrom' );
        $fromname = $mainframe->getCfg( 'fromname' );
        JUtility::sendMail($mailfrom, $fromname, $jshopConfig->contact_email, _JSHOP_ORDER_STATUS_CHANGE_TITLE, $message);
        JUtility::sendMail($mailfrom, $fromname, $order->email, _JSHOP_ORDER_STATUS_CHANGE_TITLE, $message);     
    }
    
    function _cancelPayOrder($order_id = ""){
        $session =& JFactory::getSession();
        if (!$order_id) $order_id = $session->get('jshop_end_order_id');
        if (!$order_id){
            JError::raiseWarning("", _JSHOP_SESSION_FINISH); 
            $this->setRedirect(SEFLink('index.php?option=com_jshopping&controller=checkout&task=step5',0,1));
            return 0;
        }
        
        $order = &JTable::getInstance('order', 'jshop');
        $order->load($order_id);
        $pm_method = &JTable::getInstance('paymentMethod', 'jshop');
        $pm_method->load($order->payment_method_id);
        $parseString = new parseString($pm_method->payment_params);                
        $params =  $parseString->parseStringToParams();
        $status = $params['transaction_failed_status'];
        $this->_changeStatusOrder($order_id, $status);
        
        JError::raiseWarning("", sprintf(_JSHOP_PAYMENT_CANCEL_ORDER_NUM, $order->order_id)); 
        $this->setRedirect(SEFLink('index.php?option=com_jshopping&controller=checkout&task=step5',0,1));
        return 0;
    }
    
    function _setMaxStep($step){
        $session =& JFactory::getSession();
        $jhop_max_step = $session->get('jhop_max_step');
    	if (!isset($jhop_max_step)) $session->set('jhop_max_step', 2);
        $jhop_max_step = $session->get('jhop_max_step');
    	if ($jhop_max_step < $step) $session->set('jhop_max_step', $step);
    }
    
    function deleteSession(){
        $session =& JFactory::getSession();
        
        $session->set('check_params', null);
        $session->set('cart', null);
        $session->set('jhop_max_step', null);
        $session->set('jshop_price_shipping_tax_percent', null);
        $session->set('jshop_price_shipping', null);
        $session->set('jshop_price_shipping_tax', null);
        $session->set('pm_method', null);
        $session->set('pm_params', null);        
        $session->set('payment_method_id', null);
        $session->set('shipping_method_id', null);
        $session->set('jshop_price_shipping_tax_percent', null);        
        $session->set('jshop_end_order_id', null);
        $session->set('jshop_send_end_form', null);
        $session->set('show_pay_without_reg', 0);
    }   
    
}

?>